﻿// add initializer
window.addEventListener("load", function(e) { GoJanusFFMenu.init(e); }, false);
 
function gojanusffContextListener(e)
{
	return GoJanusFFMenu.doContext(e);
}

var GoJanusFFMenu =
{
	init: function()
	{
		var menu = document.getElementById("contentAreaContextMenu");
		
		if (menu)
			menu.addEventListener("popupshowing", gojanusffContextListener, false);
	},
	doContext: function()
	{
		// default - no hide menu
		var hideMenu = false;

		// check if menu shall be hidden on non RSDN links
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].
					getService(Components.interfaces.nsIPrefBranch);
		
		if(prefs.getBoolPref("gojanusff.showOnlyOnRsdnLinks") == true)
		{
			// check link
			var topicID = GoJanusFFMenu.getRsdnTopicID();
			hideMenu = (topicID == null);
		}
		
		// hide
		document.getElementById("gojanusff-sep").hidden = hideMenu;
		document.getElementById("gojanusff-menu").hidden = hideMenu;
		
		return true;
	},
	getRsdnTopicID: function()
	{
		if(!gContextMenu.onLink)
			return null;
		
		var contextURL = gContextMenu.getLinkURL();
		if(contextURL == null)
			return null;

		var regex1 = new RegExp("http://(gzip\\.|www\\.)?rsdn\\.ru/forum/(message/|\\?action=message&gid=\\d+&mid=|\\?mid=|message\\.aspx?\\?mid=|\\?gid=\\d+&mid=|message\.)(\\d+)(\\.aspx)?","gi");
		if(regex1.test(contextURL) == false)
			return null;

		try
		{
			return parseInt(RegExp.$3);
		}
		catch(e)
		{
		}
		return null;
	},
	doOpen: function()
	{
		GoJanusFFMenu.doCmd('go');
	},
	doDownload: function()
	{
		GoJanusFFMenu.doCmd('download');
	},
	doCmd: function(cmd)
	{
		var topicID = GoJanusFFMenu.getRsdnTopicID();
		if(topicID == null)
		{
			alert("Can't get topic ID from URL.");
			return;
		}

		var gojanusff_xpcom = Components.classes['@azarkevich.at.tut.by/GoJanusFF;1'].
			createInstance(Components.interfaces.IGoJanusFF);
		if(cmd == 'go')
		{
			gojanusff_xpcom.Open(topicID);
		}
		else
		{
			gojanusff_xpcom.Download(topicID);
		}
	}
}
